#!/usr/bin/perl -X
#
# written by Hans-Jörg Bibiko - bibiko@eva.mpg.de


binmode STDIN, ':utf8';
binmode STDOUT, ':utf8';

$out_temp = $ENV{'TM_BUNDLE_SUPPORT'} . "/bin/DialogOut";

open(DIALOG,"<$out_temp");
binmode DIALOG, ':utf8';

$btn = 1;
$regExp = $ignCase = $wrap = 0;
$re = "";

while(<DIALOG>){
	chomp;
	($a,$btn) = split(/\t/) if(/returnCode\t/);
	($a,$regexp) = split(/\t/) if(/regExp\t/);
	($a,$igncase) = split(/\t/) if(/ignCase\t/);
	($a,$wrap) = split(/\t/) if(/wrapLines\t/);
	($a,$re) = split(/\t/) if(/searchString\t/);	
}
close(DIALOG);

$limit = 10000;
$limit = $ENV{'TM_HYPERSEARCH_LIMIT'} if (defined($ENV{'TM_HYPERSEARCH_LIMIT'}));
$limit += 0;

$cnt = 0;

$re =~ s/&/&amp;/g;
$re =~ s/</&lt;/g;
$re =~ s/>/&gt;/g;

$r = $re;
$r = quotemeta($re) if(!$regexp);

$wr = "normal";
$wr = "nowrap" if(!$wrap);

$mtch = 0;

if(!$btn) {
	if($r !~ /\\n/) {
		if($igncase) {
			while (<>) {
				chomp;
				s/&/&amp;/g;
				s/</&lt;/g;
				s/>/&gt;/g;
				if(/($r)/goi) {
					$cnt++;
					$col = sprintf("%02d", index($_,$1) + 1);
					last if ($cnt>$limit);
					# delimter for highlighting U+FFF3;
					$mtch += $_ =~ s/($r)/￳$1￳/gi;
					s/￳(.*?)￳/<b><i><u>$1<\/u><\/i><\/b>/g;
					s/  /&nbsp;&nbsp;/g;
					s/  /&nbsp;&nbsp;/g;
					s/  /&nbsp;&nbsp;/g;
					s/\t/ &nbsp;&nbsp&nbsp;/g;
					print "<tr><td align='right' style='color:grey'>$.:$col</td><td style='padding-left:2mm;border-left:solid 1px lightgrey;white-space:$wr'><a href='txmt:\/\/open?line=$.&column=$col' style='text-decoration:none'>$_<\/a></td></tr>\n"; 
				}
			}
			print STDERR $mtch;
		} else {
			while (<>) {
				chomp;
				s/&/&amp;/g;
				s/</&lt;/g;
				s/>/&gt;/g;
				if(/($r)/go) { 
					$cnt++;
					$col = sprintf("%02d", index($_,$1) + 1);
					last if ($cnt>$limit);
					# delimter for highlighting U+FFF3;
					s/($r)/￳$1￳/g;
					s/￳(.*?)￳/<b><i><u>$1<\/u><\/i><\/b>/g;
					s/  /&nbsp;&nbsp;/g;
					s/  /&nbsp;&nbsp;/g;
					s/  /&nbsp;&nbsp;/g;
					s/\t/ &nbsp;&nbsp&nbsp;/g;
					print "<tr><td align='right' style='color:grey'>$.:$col</td><td style='padding-left:2mm;border-left:solid 1px lightgrey'><a href='txmt:\/\/open?line=$.&column=$col' style='text-decoration:none'>$_<\/a></td></tr>\n"; 
				}
			}
			print STDERR $mtch;
		}
	} else {
		#TODO
	}
}